<template>
    <div class="d-flex justify-content-center align-items-center vh-100">
        <form @submit.prevent="submitForm" class="border p-3">
            <div class="mb-3" :class="{ 'has-validation': $v.login.$error || error.login }">
                <label for="exampleInputLogin1" class="form-label">Login</label>
                <input v-model="$v.login.$model" type="text" class="form-control" id="exampleInputLogin1"
                       :class="{ 'is-invalid': $v.login.$error || error.login }">
                <div v-if="!$v.login.required" class="invalid-feedback">
                    Login is required.
                </div>
                <div v-if="error.login" class="invalid-feedback">
                    {{ error.login }}
                </div>
            </div>
            <div class="mb-3" :class="{ 'has-validation': $v.password.$error || error.password }">
                <label for="exampleInputPassword1" class="form-label">Password</label>
                <input v-model="$v.password.$model" type="password" class="form-control" id="exampleInputPassword1"
                       :class="{ 'is-invalid': $v.password.$error || error.password }">
                <div v-if="!$v.password.required" class="invalid-feedback">
                    Password is required.
                </div>
                <div v-else-if="!$v.password.minLength || !$v.password.maxLength" class="invalid-feedback">
                    Password must be between 8 and 16 characters.
                </div>
                <div v-else-if="!$v.password.hasSpecialChar" class="invalid-feedback">
                    Password must include at least one special character.
                </div>
                <div v-else-if="!$v.password.hasUppercase" class="invalid-feedback">
                    Password must include at least one uppercase letter.
                </div>
                <div v-if="error.password" class="invalid-feedback">
                    {{ error.password }}
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
</template>

<script>
import { required, minLength, maxLength } from 'vuelidate/lib/validators'
import { mapActions, mapGetters } from 'vuex';

const hasSpecialChar = value => /[!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?]+/.test(value)
const hasUppercase = value => /[A-Z]/.test(value)

export default {
    name: 'AdminAuth',
    data() {
        return {
            login: '',
            password: ''
        }
    },
    validations: {
        login: {
            required,
        },
        password: {
            required,
            minLength: minLength(8),
            maxLength: maxLength(16),
            hasSpecialChar,
            hasUppercase
        }
    },
    computed: {
        ...mapGetters('auth', ['error'])
    },
    methods: {
        ...mapActions('auth', ['getAuth']),
        async submitForm() {
            this.$v.$touch()
            if (!this.$v.$invalid) {
                try {
                    await this.getAuth({login: this.login, password: this.password});
                    this.$router.push('/admin/employee');
                } catch (error) {
                    console.error(error);
                }
            }
        }
    }
}
</script>
